// Copyright 2019 github.com. All rights reserved.
// Use of this source code is governed by github.com.

package errors

import (
	"google.golang.org/grpc/status"
)

var (
	// 通用错误
	SystemError   = status.Error(10001, "系统错误")
	ServiceError  = status.Error(10002, "内部服务错误")
	ParamsError   = status.Error(10003, "参数错误")
	DataBaseError = status.Error(10004, "数据库错误")
	NoRecordError = status.Error(10005, "查无记录")

	//
	UserPassError     = status.Error(20001, "用户密码错误")
	UserNotExistError = status.Error(20002, "用户不存在")
	UserExistError    = status.Error(20003, "用户已存在")

	ProjectExistError    = status.Error(20004, "项目已存在")
	ProjectNotExistError = status.Error(20005, "项目不存在")

	DeviceExistError    = status.Error(20006, "设备已存在")
	DeviceNotExistError = status.Error(20007, "设备不存在")

	ProjectNotMatchError = status.Error(20008, "项目不匹配")

	UserStatusError           = status.Error(20009, "用户状态错误")
	DeviceTypeNotExistError   = status.Error(20010, "设备类型不存在")
	DeviceAddCheckError       = status.Error(20011, "设备未对接或未审批")
	DeviceDelStatusError      = status.Error(20012, "设备当前状态不能拆机")
	CanNotApproveWithStatus   = status.Error(20013, "当前状态不能审批")
	CameraBindError           = status.Error(20014, "当前设备不能绑定摄像头")
	VssStatusError            = status.Error(20015, "视频状态不支持该操作")
	ProjectProgressExistError = status.Error(20016, "已存在该进度")
	ConfError                 = status.Error(20017, "无相关配置")
	VendorError               = status.Error(20018, "三方错误")

	AlarmRuleExistError       = status.Error(20019, "告警规则已存在")
	AlarmRuleNotExistError    = status.Error(20020, "告警规则不存在")
	AlarmContactExistError    = status.Error(20021, "告警联系人已存在")
	AlarmContactNotExistError = status.Error(20022, "告警联系人不存在")

	EmailExist = status.Error(20023, "邮箱已存在")
	PhoneExist = status.Error(20024, "电话号码已存在")

	CorpExist = status.Error(20025, "参建单位已存在")
	CorpNotExist = status.Error(20026, "参建单位不存在")

	PMExist = status.Error(20027, "管理人员已存在")
	PMNotExist = status.Error(20028, "管理人员不存在")

	VehicleExist = status.Error(20029, "备案车辆已存在")
	VehicleNotExist = status.Error(20030, "备案车辆不存在")

	PmCorpNotMatch = status.Error(20031, "人员类型和参建单位类型不匹配")
	ProvincialFailed = status.Error(20032, "省厅接口调用失败")

)
