// Copyright 2019  github.com. All rights reserved.
// Use of this source code is governed by  github.com.
package alarm

import (
	"context"
	"smart-site-management/errors"
	"smart-site-management/model"
	"smart-site-management/pb/v1"

	"github.com/jaryhe/gopkgs/database"
	"go.uber.org/zap"
	"github.com/jaryhe/gopkgs/logger"
)

func AlarmRuleDelete(ctx context.Context, req *v1.AlarmRuleDeleteRequest) (reply *v1.AlarmRuleDeleteReply, err error) {
	if req.Id == 0 {
		return nil, errors.ParamsError
	}
	p := model.TAlarmRule{}
	where := map[string]interface{}{
		"ID": req.Id,
	}

	err = p.Query(database.DB(), where)
	if err != nil {
		logger.Error("AlarmRuleDelete",
			zap.String("err", err.Error()))
		return nil, errors.DataBaseError
	}
	//sn := p.Sn

	p = model.TAlarmRule{}
	err = p.Delete(database.DB(), where)
	if err != nil {
		logger.Error("AlarmRuleDelete",
			zap.String("err", err.Error()))
		return nil, errors.DataBaseError
	}
	reply = &v1.AlarmRuleDeleteReply{}

	// 清除缓存中告警规则数据
	//utils.DeleteAlarmRule(sn)

	return reply, nil
}
