// Copyright 2019  github.com. All rights reserved.
// Use of this source code is governed by  github.com.
package project

import (
	"context"
	"github.com/jaryhe/gopkgs/database"
	"smart-site-management/errors"
	"smart-site-management/model"
	"smart-site-management/pb/v1"
)

func AreaCodeList(ctx context.Context, req *v1.AreaCodeListRequest) (reply *v1.AreaCodeListReply, err error) {

	where := map[string]interface{}{}
	p := model.AreaCode{}
	list, err := p.List(database.DB(), where)
	if err != nil {
		return nil, errors.DataBaseError
	}
	reply = &v1.AreaCodeListReply{}
	reply.List = make([]*v1.AreaCodeItem, len(list))
	for i, v := range list {
		item := &v1.AreaCodeItem{
			Id:v.ID,
			AreaCode:v.Code,
			AreaAddr:v.Addr,
		}
		reply.List[i] = item
	}

	return reply, nil
}
