// Copyright 2019  github.com. All rights reserved.
// Use of this source code is governed by  github.com.
package project

import (
	"context"
	"github.com/jaryhe/gopkgs/database"
	"smart-site-management/errors"
	"smart-site-management/model"
	"smart-site-management/pb/v1"
)

func DeviceState(ctx context.Context, req *v1.DeviceStateRequest) (reply *v1.DeviceStateReply, err error) {
	if req.ProjectId <= 0 {
		return nil, errors.ParamsError
	}
	reply = &v1.DeviceStateReply{}

	where := map[string]interface{}{
		"ProjectId":req.ProjectId,
		"VerifyStatus":1,
	}
	if req.DeviceCode > 0 {
		where["DeviceCode"] = req.DeviceCode
	}
	where["DeviceState"] = 1
	p := model.DeviceAll{}
	reply.Online, err = p.Count(database.DB(), where)
	if err != nil {
		return nil, errors.DataBaseError
	}
	where["DeviceState"] = 0
	reply.Offline, err = p.Count(database.DB(), where)
	if err != nil {
		return nil, errors.DataBaseError
	}


	return reply, nil
}
