// Copyright 2019  github.com. All rights reserved.
// Use of this source code is governed by  github.com.
package project

import (
	"context"
	"github.com/jaryhe/gopkgs/database"
	"google.golang.org/grpc/status"
	"smart-site-management/errors"
	"smart-site-management/model"
	"smart-site-management/pb/v1"
)

// 删除参建单位
func ProjectCorpDel(ctx context.Context, req *v1.ProjectCorpDelRequest) (reply *v1.ProjectCorpDelReply, err error) {
	reply = &v1.ProjectCorpDelReply{}

	if req.Id == 0 || req.ProjectId == 0{
		return nil, errors.ParamsError
	}

	pm := model.ProjectPMInfo{}
	where := map[string]interface{}{
		"CorpId":req.Id,
	}
	count, err := pm.Count(database.DB(), where)
	if err != nil {
		return nil, errors.DataBaseError
	}
	if count > 0 {
		return nil, status.Error(20031, "删除参建单位，请先删除已绑定的管理人员")
	}

	p := model.ProjectCorpInfo{}
	where = map[string]interface{}{
		"ID":req.Id,
		"ProjectId":req.ProjectId,
	}

	err = p.Del(database.DB(), where)
	if err != nil {
		return nil, errors.DataBaseError
	}

	return &v1.ProjectCorpDelReply{}, nil

}
