// Copyright 2019  github.com. All rights reserved.
// Use of this source code is governed by  github.com.
package project

import (
	"context"
	"github.com/jaryhe/gopkgs/database"
	"github.com/jinzhu/gorm"
	"smart-site-management/errors"
	"smart-site-management/model"
	"smart-site-management/pb/v1"
)

// 参建单位列表
func ProjectCorpList(ctx context.Context, req *v1.ProjectCorpListRequest) (reply *v1.ProjectCorpListReply, err error) {
	reply = &v1.ProjectCorpListReply{}

	if req.ProjectId == 0 {
		return nil, errors.ParamsError
	}

	p := model.ProjectCorpInfo{}
	where := map[string]interface{}{
		"ProjectId":req.ProjectId,
	}
	list, err := p.List(database.DB(), where, 1, 100)
	if err != nil && err != gorm.ErrRecordNotFound{
		return nil, errors.DataBaseError
	}
	reply.List = make([]*v1.ProjectCorpListItem, len(list))


	for i, v := range list {
		item := &v1.ProjectCorpListItem{
			CorpType:v.CorpType,
			Name:v.CorpName,
			AreaCode:v.AreaCode,
			Id:v.ID,
			RegisterDate:v.RegisterDate.Unix(),
			SocialCode:v.CorpCode,
		}
		if v.CorpName == "" {
			item.RegisterDate = 0
		}
		reply.List[i] = item
	}

	return reply, nil
}
