// Copyright 2019  github.com. All rights reserved.
// Use of this source code is governed by  github.com.
package project

import (
	"context"
	"github.com/jaryhe/gopkgs/database"
	"github.com/jaryhe/gopkgs/logger"
	"go.uber.org/zap"
	"smart-site-management/errors"
	"smart-site-management/model"
	"smart-site-management/pb/v1"
)

func ProjectProgressDel(ctx context.Context, req *v1.ProjectProgressDelRequest) (reply *v1.ProjectProgressDelReply, err error) {
	reply = &v1.ProjectProgressDelReply{}

	if req.Id == 0 {
		return nil, errors.ParamsError
	}
	p := model.TProjectSchedule{}
	where := map[string]interface{}{
		"ID":req.Id,
	}
	err = p.Del(database.DB(), where)
	if err != nil {
		logger.Error("ProjectProgressDel",
			zap.String("err", err.Error()))
		return nil, errors.DataBaseError
	}
	return reply, nil
}
