// Copyright 2019  github.com. All rights reserved.
// Use of this source code is governed by  github.com.
package project

import (
	"context"
	"github.com/jaryhe/gopkgs/database"
	"smart-site-management/errors"
	"smart-site-management/model"
	"smart-site-management/pb/v1"
)

// 删除管理人员
func ProjectPMDel(ctx context.Context, req *v1.ProjectPMDelRequest) (reply *v1.ProjectPMDelReply, err error) {
	reply = &v1.ProjectPMDelReply{}

	if req.Id == 0 || req.ProjectId == 0 {
		return nil, errors.ParamsError
	}

	p := model.ProjectPMInfo{}
	where := map[string]interface{}{
		"ID":req.Id,
		"ProjectId":req.ProjectId,
	}

	p.ID = 0
	err = p.Del(database.DB(), where)
	if err != nil {
		return nil, errors.DataBaseError
	}

	return &v1.ProjectPMDelReply{}, nil

}
