// Copyright 2019  github.com. All rights reserved.
// Use of this source code is governed by  github.com.
package project

import (
	"context"
	"github.com/jaryhe/gopkgs/database"
	"smart-site-management/errors"
	"smart-site-management/model"
	"smart-site-management/pb/v1"
)

// 删除备案车辆
func ProjectVehicleDel(ctx context.Context, req *v1.ProjectVehicleDelRequest) (reply *v1.ProjectVehicleDelReply, err error) {
	reply = &v1.ProjectVehicleDelReply{}

	if req.Id == 0 || req.ProjectId == 0{
		return nil, errors.ParamsError
	}

	p := model.VehicleRecord{}
	where := map[string]interface{}{
		"ID":req.Id,
		"ProjectId":req.ProjectId,
	}

	p.ID = 0
	err = p.Del(database.DB(), where)
	if err != nil {
		return nil, errors.DataBaseError
	}

	return &v1.ProjectVehicleDelReply{}, nil

}
