package model

import "github.com/jinzhu/gorm"

type AreaCode struct {
	ID int64 `gorm:"column:ID"`
	Code string `gorm:"column:Code"`
	Addr string `gorm:"column:Addr"`
}

func (AreaCode) TableName() string {
	return "AreaCode"
}

func (p *AreaCode) List(db *gorm.DB, where map[string]interface{}) (list []AreaCode, err error) {

	if len(where) > 0 {
		cond, val, err := whereBuild(where)
		if err != nil {
			return list, err
		}
		result := db.Table(p.TableName()).Where(cond, val...).Find(&list)

		return list, result.Error
	}

	result := db.Table(p.TableName()).Find(&list)
	return list, result.Error
}

func (p *AreaCode) Find(db *gorm.DB, where map[string]interface{}) error {
	cond, val, err := whereBuild(where)
	if err != nil {
		return err
	}
	return db.Table(p.TableName()).Where(cond, val...).First(p).Error
}

func (p *AreaCode) Count(db *gorm.DB, where map[string]interface{}) (int64, error) {
	if len(where) > 0 {
		cond, val, err := whereBuild(where)
		if err != nil {
			return 0, err
		}
		ret := int64(0)
		err = db.Table(p.TableName()).Where(cond, val...).Count(&ret).Error

		return ret, err
	}
	ret := int64(0)
	err := db.Table(p.TableName()).Count(&ret).Error
	return ret, err
}
