package model

import (
	"github.com/jinzhu/gorm"
	"time"
)

type ProjectCorpInfo struct {
	ID int64 `gorm:"column:ID;PRIMARY_KEY"`
	Code string `gorm:"column:Code"`
	CorpName string `gorm:"column:CorpName"`
	AreaCode string `gorm:"column:AreaCode"`
	CorpCode string `gorm:"column:CorpCode"`
	RegisterDate time.Time `gorm:"column:RegisterDate"`
	CorpType uint32 `gorm:"column:CorpType"`
	ProjectId int64 `gorm:"column:ProjectId"`
	CreatedAt   time.Time `gorm:"column:CreatedAt"`
	UpdatedAt   time.Time `gorm:"column:UpdatedAt"`
}



func (ProjectCorpInfo) TableName() string {
	return "ProjectCorpInfo"
}

func (p *ProjectCorpInfo) Insert(db *gorm.DB) error {
	return db.Table(p.TableName()).Create(p).Error
}

func (p *ProjectCorpInfo) Del(db *gorm.DB, where map[string]interface{}) error {
	cond, val, err := whereBuild(where)
	if err != nil {
		return err
	}
	return db.Table(p.TableName()).Where(cond, val...).Delete(p).Error
}

func (p *ProjectCorpInfo) Find(db *gorm.DB, where map[string]interface{}) error {
	cond, val, err := whereBuild(where)
	if err != nil {
		return err
	}
	return db.Table(p.TableName()).Where(cond, val...).First(p).Error
}

func (p *ProjectCorpInfo) Update(db *gorm.DB, where map[string]interface{}, values map[string]interface{}) error {
	cond, val, err := whereBuild(where)
	if err != nil {
		return err
	}

	return db.Table(p.TableName()).Where(cond, val...).Updates(values).Error
}

func (p *ProjectCorpInfo) FindSort(db *gorm.DB, where map[string]interface{}, sort string) error {
	cond, val, err := whereBuild(where)
	if err != nil {
		return err
	}
	ps := []ProjectCorpInfo{}
	err = db.Table(p.TableName()).Where(cond, val...).Order(sort).Limit(1).Find(&ps).Error
	if err != nil {
		return err
	}
	if len(ps) > 0 {
		*p = ps[0]
	}
	return nil
}



func (p *ProjectCorpInfo) Count(db *gorm.DB, where map[string]interface{}) (int64, error) {
	if len(where) > 0 {
		cond, val, err := whereBuild(where)
		if err != nil {
			return 0, err
		}
		ret := int64(0)
		err = db.Table(p.TableName()).Where(cond, val...).Count(&ret).Error

		return ret, err
	}
	ret := int64(0)
	err := db.Table(p.TableName()).Count(&ret).Error
	return ret, err
}

func (p *ProjectCorpInfo) List(db *gorm.DB, where map[string]interface{}, page int32, pageSize int32) (list []ProjectCorpInfo, err error) {
	offset := int64(page - 1)*int64(pageSize)
	if len(where) > 0 {
		cond, val, err := whereBuild(where)
		if err != nil {
			return list, err
		}

		result := db.Table(p.TableName()).Where(cond, val...).Limit(pageSize).Offset(offset).Find(&list)

		return list, result.Error
	}
	result := db.Table(p.TableName()).Limit(pageSize).Offset(offset).Find(&list)

	return list, result.Error

}

func (p *ProjectCorpInfo) All(db *gorm.DB, where map[string]interface{}) (list []ProjectCorpInfo, err error) {

	if len(where) > 0 {
		cond, val, err := whereBuild(where)
		if err != nil {
			return nil, err
		}
		result := db.Table(p.TableName()).Where(cond, val).Find(&list)
		return list, result.Error
	}
	result := db.Table(p.TableName()).Find(&list)

	return list, result.Error
}
