package model

import (
	"github.com/jinzhu/gorm"
	"time"
)


type ProjectPMInfo struct {
	ID int64 `gorm:"column:ID;PRIMARY_KEY"`
	Code string `gorm:"column:Code"`
	CorpName string `gorm:"column:CorpName"`
	CorpCode string `gorm:"column:CorpCode"`
	CorpType uint32 `gorm:"column:CorpType"`
	PType uint32 `gorm:"column:PType"`
	PMName string `gorm:"column:PMName"`
	PMIDCardType uint32 `gorm:"column:PMIDCardType"`
	PMIDCardNumber string `gorm:"column:PMIDCardNumber"`
	PMPhone string `gorm:"column:PMPhone"`
	ProjectId int64 `gorm:"column:ProjectId"`
	CorpId int64 `gorm:"column:CorpId"`
	CreatedAt   time.Time `gorm:"column:CreatedAt"`
	UpdatedAt   time.Time `gorm:"column:UpdatedAt"`
}

func (ProjectPMInfo) TableName() string {
	return "db_smart_attendance.ProjectPMInfo"
}

func (p *ProjectPMInfo) Insert(db *gorm.DB) error {
	return db.Table(p.TableName()).Create(p).Error
}

func (p *ProjectPMInfo) Del(db *gorm.DB, where map[string]interface{}) error {
	cond, val, err := whereBuild(where)
	if err != nil {
		return err
	}
	return db.Table(p.TableName()).Where(cond, val...).Delete(p).Error
}

func (p *ProjectPMInfo) Find(db *gorm.DB, where map[string]interface{}) error {
	cond, val, err := whereBuild(where)
	if err != nil {
		return err
	}
	return db.Table(p.TableName()).Where(cond, val...).First(p).Error
}

func (p *ProjectPMInfo) Update(db *gorm.DB, where map[string]interface{}, values map[string]interface{}) error {
	cond, val, err := whereBuild(where)
	if err != nil {
		return err
	}

	return db.Table(p.TableName()).Where(cond, val...).Updates(values).Error
}

func (p *ProjectPMInfo) FindSort(db *gorm.DB, where map[string]interface{}, sort string) error {
	cond, val, err := whereBuild(where)
	if err != nil {
		return err
	}
	ps := []ProjectPMInfo{}
	err = db.Table(p.TableName()).Where(cond, val...).Order(sort).Limit(1).Find(&ps).Error
	if err != nil {
		return err
	}
	if len(ps) > 0 {
		*p = ps[0]
	}
	return nil
}



func (p *ProjectPMInfo) Count(db *gorm.DB, where map[string]interface{}) (int64, error) {
	if len(where) > 0 {
		cond, val, err := whereBuild(where)
		if err != nil {
			return 0, err
		}
		ret := int64(0)
		err = db.Table(p.TableName()).Where(cond, val...).Count(&ret).Error

		return ret, err
	}
	ret := int64(0)
	err := db.Table(p.TableName()).Count(&ret).Error
	return ret, err
}

func (p *ProjectPMInfo) List(db *gorm.DB, where map[string]interface{}, page int32, pageSize int32) (list []ProjectPMInfo, err error) {
	offset := int64(page - 1)*int64(pageSize)
	if len(where) > 0 {
		cond, val, err := whereBuild(where)
		if err != nil {
			return list, err
		}

		result := db.Table(p.TableName()).Where(cond, val...).Limit(pageSize).Offset(offset).Find(&list)

		return list, result.Error
	}
	result := db.Table(p.TableName()).Limit(pageSize).Offset(offset).Find(&list)

	return list, result.Error

}
