package model

import (

	"github.com/jinzhu/gorm"
	"time"

)

type Slagcar struct {
	ID int64 `gorm:"column:ID" json:"ID" form:"id"`
	Code string `gorm:"column:Code" json:"Code" form:"code"`
	Devicenumber string `gorm:"column:deviceNumber" json:"deviceNumber" form:"devicenumber"`
	Carnumber string `gorm:"column:carNumber" json:"carNumber" form:"carnumber"`
	Snapdate time.Time `gorm:"column:snapDate" json:"snapDate" form:"snapdate"`
	Inout int64 `gorm:"column:InOut" json:"InOut" form:"inout"`
	Isrecord string `gorm:"column:isRecord" json:"isRecord" form:"isrecord"`
	Carmodel int64 `gorm:"column:carModel" json:"carModel" form:"carmodel"`
	Cleanimg string `gorm:"column:cleanImg" json:"cleanImg" form:"cleanimg"`
	Carnumimg string `gorm:"column:carNumImg" json:"carNumImg" form:"carnumimg"`
	Url string `gorm:"column:Url" json:"Url" form:"url"`
	Sn string `gorm:"column:SN" json:"SN"`
	ProjectId int64 `gorm:"column:ProjectId" json:"ProjectId"`
	// 仅供influxdb使用
	Time string `gorm:"-" json:"time"`
}

func (Slagcar) TableName() string {
	return "Slagcar"
}

func (p *Slagcar) Insert(db *gorm.DB) error {
	return db.Table(p.TableName()).Create(p).Error
}

func (p *Slagcar) Del(db *gorm.DB, where map[string]interface{}) error {
	cond, val, err := whereBuild(where)
	if err != nil {
		return err
	}
	return db.Table(p.TableName()).Where(cond, val...).Delete(p).Error
}

func (p *Slagcar) Find(db *gorm.DB, where map[string]interface{}) error {
	cond, val, err := whereBuild(where)
	if err != nil {
		return err
	}
	return db.Table(p.TableName()).Where(cond, val...).First(p).Error
}

func (p *Slagcar) Update(db *gorm.DB, where map[string]interface{}, values map[string]interface{}) error {
	cond, val, err := whereBuild(where)
	if err != nil {
		return err
	}

	return db.Table(p.TableName()).Where(cond, val...).Updates(values).Error
}

func (p *Slagcar) FindSort(db *gorm.DB, where map[string]interface{}, sort string) error {
	cond, val, err := whereBuild(where)
	if err != nil {
		return err
	}
	ps := []Slagcar{}
	err = db.Table(p.TableName()).Where(cond, val...).Order(sort).Limit(1).Find(&ps).Error
	if err != nil {
		return err
	}
	if len(ps) > 0 {
		*p = ps[0]
	}
	return nil
}



func (p *Slagcar) Count(db *gorm.DB, where map[string]interface{}) (int64, error) {
	if len(where) > 0 {
		cond, val, err := whereBuild(where)
		if err != nil {
			return 0, err
		}
		ret := int64(0)
		err = db.Table(p.TableName()).Where(cond, val...).Count(&ret).Error

		return ret, err
	}
	ret := int64(0)
	err := db.Table(p.TableName()).Count(&ret).Error
	return ret, err
}

func (p *Slagcar) List(db *gorm.DB, where map[string]interface{}, page int32, pageSize int32) (list []Slagcar, err error) {
	offset := int64(page - 1)*int64(pageSize)
	if len(where) > 0 {
		cond, val, err := whereBuild(where)
		if err != nil {
			return list, err
		}

		result := db.Table(p.TableName()).Where(cond, val...).Order("snapDate desc").Limit(pageSize).Offset(offset).Find(&list)

		return list, result.Error
	}
	result := db.Table(p.TableName()).Limit(pageSize).Offset(offset).Find(&list)

	return list, result.Error

}
