package model

import (
	"github.com/jaryhe/gopkgs/database"
	"github.com/jinzhu/gorm"
	"sync"
)

type WorkType struct {
	Id int64 `gorm:"column:ID;PRIMARY_KEY"`
	Code string `gorm:"column:Code"`
	Type string `gorm:"column:Type"`
}
var wmux sync.Mutex
var WorkTypeMap =  map[string]string{}

func (WorkType) TableName() string {
	return "db_smart_attendance.WorkType"
}

func (p *WorkType) All(db *gorm.DB) (list []WorkType, err error) {

	result := db.Table(p.TableName()).Find(&list)

	return list, result.Error
}

func GetWorkItemMap() (map[string]string, error){
	wmux.Lock()
	defer wmux.Unlock()
	if len(WorkTypeMap) > 0 {
		return WorkTypeMap, nil
	}
	p := &WorkType{}
	list, err := p.All(database.DB())
	if err != nil {
		return WorkTypeMap, err
	}
	for _, v := range list {
		WorkTypeMap[v.Code] = v.Type
	}
	return WorkTypeMap, nil
}
